import { App as BaseApp } from '../common/app';

interface BackendParams<App extends BaseApp> {
	app: App;
}

export interface Backend<App extends BaseApp = BaseApp> {
	app: App;
}

class BackendInstance<App extends BaseApp> implements Backend<App> {
	readonly app: App;

	constructor(params: BackendParams<App>) {
		this.app = params.app;
	}
}

export const backend = <App extends BaseApp>(params: BackendParams<App>): Backend<App> => {
	return new BackendInstance(params);
};
