import { Backend as BaseBackend } from './index';
import http from 'http';

interface ServerParams<Backend extends BaseBackend = BaseBackend> {
	backend: Backend;
}

export interface Server<Backend extends BaseBackend = BaseBackend> {
	backend: Backend;
	host(params: ServiceParams): this;
}

class ServerInstance<Backend extends BaseBackend> implements Server<Backend> {
	readonly backend: Backend;
	private readonly serverInternal;

	constructor(params: ServerParams<Backend>) {
		this.backend = params.backend;
		this.serverInternal = new http.Server(this.requestListener);
	}

	private readonly requestListener = (req, res) => {

	};

	host(params: ServiceParams) {
		this.serverInternal.listen(params.port, params.host);
		return this;
	}
}

export const server = <Backend extends BaseBackend>(params: ServerParams<Backend>): Server<Backend> => {
	return new ServerInstance(params);
};
