import { App as BaseApp } from '../common/app';

interface ClientParams<App extends BaseApp> {
	app: App;
}

interface Client<App extends BaseApp> {
	app: App;
	connect(params: ServiceParams): this;
}

class ClientInstance<App extends BaseApp> implements Client<App> {
	readonly app: App;
	private connection: ServiceParams;

	constructor(params: ClientParams<App>) {
		this.app = params.app;
	}

	connect(params: ServiceParams) {
		this.connection = params;
		return this;
	}
}

export const client = <App extends BaseApp>(params: ClientParams<App>): Client<App> => {
	return new ClientInstance(params);
};
