import {app, endpoint, operation, validation as v} from './common/app';

const theEndpoint = endpoint({
  schema: v.object({
    username: v.string(),
  }),
})
  .can('patch')
  .can('query');

const canPatch = operation({
  name: 'patch' as const,
  args: [
    'merge',
    'delta',
  ] as const,
  // TODO define resource-specific stuff, like defining URL params, etc.
});

const canFetch = operation({
  name: 'fetch' as const,
  args: [
    'item',
    'collection',
  ] as const,
});

const canQuery = operation({
  name: 'query' as const,
});

const canCreate = operation({
  name: 'create' as const,
});

const canEmplace = operation({
  name: 'emplace' as const,
});

const canDelete = operation({
  name: 'delete' as const,
});

export const theApp = app({
  name: 'foo' as const,
})
  .operation(canQuery)
  .operation(canPatch)
  .operation(canFetch)
  .operation(canCreate)
  .operation(canEmplace)
  .operation(canDelete)
  .endpoint(theEndpoint);
//
// const bootstrap = async (theApp: App) => {
//   if (typeof window === 'undefined') {
//     const { backend } = await import('./backend');
//     const theBackend = backend({
//       app: theApp
//     });
//   }
// };
